#ifndef _indexer_h_included_
#define _indexer_h_included_

#include<string>
#include<hash_map>
#include<map>

using namespace std;

#define BUFSIZE 1024
#define KEYSIZE 7 //size of keys in hash multimap
#define INDEXSIZE /*65536*/16384

typedef stdext::hash_multimap<string, int> hashmap;
typedef map<int, int> tallier;

struct score {
	int quality;
	unsigned int index;
	//also should store length of read

	score() {
		quality = 0;
		index = UINT_MAX;
	}
};

class indexer {
public:
	//Takes in file name of genome reference and indexes that genome
	int index(const string filename, const string testCases);

	//finds the index in geneIndex of a string, read, that is passed in
	int map(const string read);

	//hash function
	int hash(const string key);

	int commitResults(const string resultsFile);

	indexer();

private:
	//hashmap geneIndex;
	tallier indexScore;
	vector<int> *geneIndex[INDEXSIZE];
	vector<score> LTscore;

};

#endif