// Raymond Moy
// 203484560

#include <string>
#include <iostream>
#include <iomanip>
#include <fstream>

using namespace std;

#include "indexer.h"

#ifdef _MSC_VER  // If we're compiling for Windows

//***************
// These definitions make up for problems including <windows.h>
typedef int BOOL;
typedef unsigned long DWORD;
typedef long LONG;
typedef long long LONGLONG;
typedef union _LARGE_INTEGER {
    struct {
        DWORD LowPart;
        LONG HighPart;
    };
    struct {
        DWORD LowPart;
        LONG HighPart;
    } u;
    LONGLONG QuadPart;
} LARGE_INTEGER;
extern "C" __declspec(dllimport) BOOL __stdcall QueryPerformanceCounter(LARGE_INTEGER*);
extern "C" __declspec(dllimport) BOOL __stdcall QueryPerformanceFrequency(LARGE_INTEGER*);
//***************

typedef LARGE_INTEGER TimerType;
inline TimerType getTimer()
{
    LARGE_INTEGER t;
    QueryPerformanceCounter(&t);
    return t;
}

inline double interval(TimerType start, TimerType stop)
{
    LARGE_INTEGER ticksPerSecond;
    QueryPerformanceFrequency(&ticksPerSecond);
    return (1000.0 * (stop.QuadPart - start.QuadPart)) / ticksPerSecond.QuadPart;
}

#else // If we're not compiling for Windows, use Standard C

#include <ctime>

typedef clock_t TimerType;
inline TimerType getTimer() { return clock(); }
inline double interval(TimerType start, TimerType stop)
{
    return (1000.0 * (stop - start)) / CLOCKS_PER_SEC;
}

#endif  // ifdef _MSC_VER

/* Give main three arguments: a file containing a reference genome,
	a file containing the substrings of an example genome, and the 
	file you would like created to return the indices of the submitted
	substrings. The	file containing the substrings must have each line
	formatted as follows:
	[substring][whitespace][junk that won't be read]\n
	The file containing the results will be formatted as follows:
	[substring] [index]\n
	It is recommended that the substrings be of at least length 30 for
	accurate results.
*/

int main( )
{
	indexer genomeRef;

	cout << "Enter the name of a text file that "
         << "contains the reference genome in  " << endl;
    cout << "one line of text: ";

	string masterFile, inputFile, resultsFile;				// uncomment if you want to prompt for file searched
    getline(cin, masterFile);
	
	cout << "Enter the name of a text file that "
         << "contains the reads to map, with one " << endl;
    cout << "read per line of text: ";
	
	getline(cin, inputFile);

	cout << "Enter the name of a text file that "
		 << "you would like to store the results: ";
	
	getline(cin, resultsFile);

	cout << "Mapping..." << flush;

	TimerType start = getTimer();

	genomeRef.index(masterFile, inputFile);		//TODO: error checking

	TimerType end = getTimer();
    cout << "took " << interval(start, end) << " milliseconds." << endl;

	genomeRef.commitResults(resultsFile);

	//cout << "Enter the name of a text file that "				//TODO: should put this into loop
 //        << "contains strings of nucleotides" << endl;
 //   cout << "to be mapped to the reference genome: ";

					
    //getline(cin, inputFile); // uncomment if you want to prompt for file

	//cout << inputFile << endl;

	//cout << "Enter the name of a file you want "
	//	 << "created to store the results in: ";

	//string outputFile = "testresults.txt";				
 //   //getline(cin, outputFile); // uncomment if you want to prompt for file

	//cout << outputFile << endl;

	//cout << "Mapping reads..." << flush;
 //   
	//start = getTimer();

	//genomeRef.map(inputFile, outputFile);		//TODO: error checking

	//end = getTimer();
	//cout << "took " << interval(start, end) << " milliseconds." << endl;

}




//start with indexing

